/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.stormacq.demo.nxt;

//jersey
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.ws.rs.DefaultValue;
import javax.ws.rs.Path;
import javax.ws.rs.GET;
import javax.ws.rs.Produces;
import javax.ws.rs.QueryParam;

//json
import org.codehaus.jettison.json.*;


/**
 * REST Web Service
 *
 * @author sst
 */

@Path("colorsensor")
public class ColorSensorResource {

    private Robot robot = null;

    private static final String JSON_RESPONSE_SENSORPORT = "sensorportnumber";
    private static final String JSON_RESPONSE_SENSOR_COLOR_NAME = "name";
    private static final String JSON_RESPONSE_SENSOR_COLOR_VALUE = "value";
    private static final String JSON_RESPONSE_STATUS = "status";

    /**
     * Retrieves representation of an instance of com.stormacq.demo.nxt.DeviceResource
     * @return an instance of java.lang.String
     */
    @GET
    @Produces("application/json")
    public String getJson(@QueryParam("sensorPortNumber") @DefaultValue("3") int sensorPortNumber) {

        String result = null;

        if (robot == null) {
            robot = Robot.getSingleton();
        }

        try {

            //robot.connect();

            result = new JSONStringer()
                    .object()
                    .key(JSON_RESPONSE_SENSORPORT)
                    .value(sensorPortNumber)
                    .key(JSON_RESPONSE_SENSOR_COLOR_NAME)
                    .value(robot.getColorName(sensorPortNumber))
                    .key(JSON_RESPONSE_SENSOR_COLOR_VALUE)
                    .value((double)robot.getColorValue(sensorPortNumber))
                    .key(JSON_RESPONSE_STATUS)
                    .value("OK")
                    .endObject()
                    .toString();

            //robot.disconnect();

        } catch (Exception ex) {
            String msg = "Can not read Color Sensor value";
            Logger.getLogger(PilotResource.class.getName()).log(Level.WARNING, msg, ex);
            result = "{ \"status\" : \"" + msg + "\" }";
            robot = null;
        }

        return result;
    }


}
