/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.stormacq.demo.nxt;

//jersey
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.ws.rs.Path;
import javax.ws.rs.GET;
import javax.ws.rs.Produces;

//json
import org.codehaus.jettison.json.*;


/**
 * REST Web Service
 *
 * @author sst
 */

@Path("device")
public class DeviceResource {

    private Robot robot = null;

    private static final String JSON_RESPONSE_DEVICENAME = "name";
    private static final String JSON_RESPONSE_BATERYLEVEL = "baterylevel";
    private static final String JSON_RESPONSE_FIRMWAREVERSION = "firmwareversion";
    private static final String JSON_RESPONSE_STATUS = "status";

    /**
     * Retrieves representation of an instance of com.stormacq.demo.nxt.DeviceResource
     * @return an instance of java.lang.String
     */
    @GET
    @Produces("application/json")
    public String getJson() {

        String result = null;

        if (robot == null) {
            robot = Robot.getSingleton();
        }

        try {

            robot.connect();

            result = new JSONStringer()
                    .object()
                    .key(JSON_RESPONSE_DEVICENAME)
                    .value(robot.getDeviceName())
                    .key(JSON_RESPONSE_BATERYLEVEL)
                    .value((double)robot.getDeviceBateryLevel())
                    .key(JSON_RESPONSE_FIRMWAREVERSION)
                    .value(robot.getDeviceFirmwareVersion())
                    .key(JSON_RESPONSE_STATUS)
                    .value("OK")
                    .endObject()
                    .toString();

            robot.disconnect();

        } catch (Exception ex) {
            String msg = "Can not get device information";
            Logger.getLogger(PilotResource.class.getName()).log(Level.WARNING, msg, ex);
            result = "{ \"status\" : \"" + msg + "\" }";
            robot = null;
        }

        return result;
    }

}
